import { Entity, ManyToMany } from 'typeorm';
import { BaseEntity } from '../base-entity';
import { MultiNamed } from './base/multi-named';
import { Book } from './book';
import { Fiction } from './fiction';

@Entity()
export class Character extends MultiNamed(BaseEntity) {
  @ManyToMany(() => Book, {
    nullable: false,
    onDelete: 'CASCADE',
    onUpdate: 'CASCADE',
  })
  public books: Promise<Book[]>;

  @ManyToMany(() => Fiction, {
    nullable: true,
    onDelete: 'CASCADE',
    onUpdate: 'CASCADE',
  })
  public fictions: Promise<Fiction[]>;
}
